// *************************************************************************
// [内容] 掲示板介入 content_scripts スクリプト。
// [詳細] カテゴリー覧の介入を実施する。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [関数] カテゴリー覧が存在する場合、その内容を読み取り、ストレージに保存する。
function AccordionAnalyze() {
	var aryBoards = [];
	var records = 0;
	var elAccordion = document.getElementById("accordion");
	try {
		var eDs = elAccordion.getElementsByTagName('a');
		for (var eDi = 0; eDi < eDs.length; eDi++) {
			if (records >= 99) {
				// 不正なデーターなので墜とす
				return;
			}
			var enabled = false;
			var board = 0;
			var threads = 0;
			var hot = false;
			var elA = eDs[eDi];
			s = elA.getAttribute("href");
			if (s) {
				s = s.trim();
				var result = (s.match(/^\/(jp|kr)\/board\/exc_board_(\d+)/) || [])[2];
				if (result != undefined) {
					if (result >= 1 && result <= 99) {
						board = result;
						var elRecord = elA.parentNode;
						var elBadges = elRecord.getElementsByClassName("badge");
						if (elBadges && elBadges.length >= 1) {
							var elBadge = elBadges[0];
							threads = elBadge.textContent.trim(); // このカテゴリーの現在の全スレッド数を獲得
							if (!isNaN(threads)) {
								var elTextDangers = elRecord.getElementsByClassName("text-danger");
								if (elTextDangers && elTextDangers.length >= 1) {
									// このカテゴリーは現在新スレッドがあるホットな状態
									hot = true;
								}
								enabled = true;
								records++;
							}
						}
					}
				}
			}
			if (enabled) {
				var text = board + "," + threads + "," + (hot ? "1" : "0");
				aryBoards.push(text);
			}
		}
		if (records >= 1) {
			// 獲得したリストをローカルストレージに保存する
			var boardInfoText = aryBoards.join(":");
			browser.storage.local.set({
				kjclub_boardsinfo: boardInfoText
			});
		}
	}
	catch(e) {
	}
}