// *************************************************************************
// [内容] 掲示板介入 content_scripts スクリプト。
// [詳細] 掲示板への各種施術を実現するためのメインスクリプト。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [警告] このスクリプトのAMO等での審査について
// このスクリプトは、innerHTMLを使用する等、問題のある手法を使用しています。

// [関数] スレッド内容の本文を再構築する(パースする)
function rebuildContent() {
	var fAlert = false;
	var fMobile = isMobileDocument();

	// 対象とするタグのリスト
	var aryTags = ["iframe","xmp"];

	// 警告メッセージ
	var sCaution = "\r\n\r\n\r\n" + "<!-- Rebuild by " + i18n('KJPlusExtensionName', 'KJCLUB Plus') + " -->\r\n" + (fMobile ? "<div style='position:fixed; bottom:0px; left:0px; right:0px; z-index:40000;'>" : "") + "<hr>\r\n" + "<div style='padding:0.2em; text-align:center; font-weight:bold; border:1px solid black; color:red; background:white;'>" + "\t<div>このスレッドの投稿本文に致命的な構文異常を発見しました。" + (fMobile ? "</div>" : "これ以降の文書は" + i18n('KJPlusExtensionName', 'KJCLUB Plus') + "が強制的にリビルドしたものです。</div>") + (fMobile ? "" : "\t<div>この問題はKJCLUB投稿システム側のHTMLパース処理が甘いことが原因と考えられます。</div>") + (fMobile ? "" : "\t<div>KJCLUBのバグ報告板で管理人に報告しましょう。</div>") + (fMobile ? "" : "</div>\r\n") + (fMobile ? "" : "<hr>\r\n") + (fMobile ? "" : "<div style='padding:0.2em; text-align:center; font-weight:bold; border:1px solid black; color:red; background:white;'>") + "\t<div>なお、このスレッドにコメントしても、おそらくはKJCLUB Plus+利用者以外は閲覧できません。</div>" + "</div>\r\n" + "<hr>\r\n" + (fMobile ? "</div>" : "") + "\r\n\r\n";

	// スレッド内容コンテンツの解析開始
	var eContent = document.getElementById("write_content");
	if (!eContent) {
		return;
	}

	for (var sTagName of aryTags) {
		for (var eElm of eContent.getElementsByTagName(sTagName)) {
			var lengthElm = eElm.innerHTML.length; // Broken node check
			if (lengthElm >= 10000) {
				// 異常なノード(閉じていない?)
				console.log("異常な" + sTagName + "ノードを発見(閉じていない??)");
				fAlert = true;
			}
		}
	}

	if (fAlert) {
		// コメントの再充填を実行
		var sDoc = document.body.innerHTML;

		var iBody = sDoc.indexOf("<body");
		iBody = sDoc.indexOf(">", iBody);
		iBody++;

		var iBodyEnd = sDoc.lastIndexOf("</body");

		var sStart = "<div id=\"write_content\">";
		var iStart = sDoc.indexOf(sStart);
		var iEnd = sDoc.lastIndexOf("<div class=\"display_content_lang\">");

		if (iStart >= 0 && iEnd >= 0) {
			iStart += sStart.length;
			iEnd = sDoc.lastIndexOf("</div>", iEnd);
			if (iStart >= 0 && iEnd >= 0) {
				sContent = sDoc.slice(iStart, iEnd);

				let parser = new DOMParser();
				let doc = parser.parseFromString(sContent, "text/html");

				// 再構成されたBODY内容のHTMLテキストを獲得する
				sDoc = sDoc.slice(iBody, iStart) + doc.body.innerHTML + sCaution + sDoc.slice(iEnd, iBodyEnd);

				// 再度パースしてノードリストを得る
				let docBody = parser.parseFromString(sDoc, "text/html");

				// <script>タグを抽出し、後でインジェクションするために退避する
				var elScripts = docBody.getElementsByTagName("script");
				var aryScripts = [];
				for (let els of elScripts) {
					if (els.src) {
						aryScripts.push({
							request: "src",
							src: els.src
						});
					} else {
						var sScript = els.innerHTML;
						sScript = sScript.replace(/\/\/<!\[CDATA\[/ig, "").replace(/\/\/]]>/ig, "");
						aryScripts.push({
							request: "direct",
							data: sScript
						});
					}
				}

				// <script>タグをすべて削除する
				for (var i = elScripts.length - 1; i >= 0; i--) {
					var node = elScripts[i];
					node.parentNode.removeChild(node);
				}

				// <body>の内容を全削除
				var el = document.body;
				while (el.firstChild) {
					el.removeChild(el.firstChild);
				}

				// 再構成されたノードを挿入
				document.body.appendChild(docBody.body);

				// ノード挿入後に、<script>をインジェクションする
				for (let script of aryScripts) {
					if (script.request == "src") {
						ScriptLoader([script.src]);
					} else
					if (script.request == "direct") {
						ScriptInjector([script.data]);
					}
				}

				eContent = document.getElementById("write_content");
				
				// 再構築完了後に、フィルタ処理をあらためて実施する
			}
		}
	}

	if (eContent) {
		// アドオンリフレッシュ時など、既に介入済みのページの場合があるので、既存の表示介入を一旦全て除去する
		try {
			for (let eElm of eContent.getElementsByClassName("kjp-addlink")) {
				eElm.parentNode.removeChild(eElm);
			}
		}
		catch(e) {
		}
		// iframeがある場合、モバイル等ではsrcの内容が正常に表示されない場合があるので、リンクを補助する
		try	{
			for (let eElm of eContent.getElementsByTagName("iframe")) {
				let src=eElm.getAttribute("src");
				if( src ) {
					let message="Iframe";
					
					/// YouTubeの処理
					let aYouTube = src.match(/^(https:\/\/|http:\/\/|\/\/)www\.youtube\.com\/embed\/([\-\w]+)/);
					if( aYouTube && aYouTube.length >= 3 ) {
						message="YouTube"
						src="https://youtu.be/"+aYouTube[2];
					}
					/// DailyMotionの処理
					let aDailyMotion = src.match(/^(https:\/\/|http:\/\/|\/\/)www\.dailymotion\.com\/embed\/video\/([\-\w]+)/);
					if( aDailyMotion && aDailyMotion.length >= 3 ) {
						message="dailymotion"
						src="https://dai.ly/"+aDailyMotion[2];
					}
					/// ニコニコ動画の処理
					let aNicoVideo = src.match(/^(https:\/\/|http:\/\/|\/\/)ext\.nicovideo\.jp\/thumb\/([\w]+)/);
					if( aNicoVideo && aNicoVideo.length >= 3 ) {
						message="niconico"
						src="https://nico.ms/"+aNicoVideo[2];
					}
					
					// リンクが長すぎるときは短くする
					let srcText=src;
					if( (message.length + srcText.length) >= 45 ) {
						srcText=srcText.substring(0,43-(message.length))+"...";
					}
					// フレームを加工
					eElm.style.border="1px solid gray";
					// リンクの表示スペースを作るために、改行を入れる
					// let elBr = document.createElement('br');
					// eElm.parentNode.insertBefore(elBr, eElm.nextSibling); 
					// リンクの作成
					let elDiv = document.createElement('div');
					elDiv.classList.add('kjp-addlink');
					let elHeadSpan = document.createElement('span');
					elHeadSpan.classList.add('kjp-addlink-header');
					let elHeadText = document.createTextNode(message);
					let elLink = document.createElement('a');
					elLink.classList.add('kjp-addlink-link');
					elLink.setAttribute("href", src);
					elLink.setAttribute("target", "_new");
					let elText = document.createTextNode(srcText);
					elLink.appendChild(elText);
					elHeadSpan.appendChild(elHeadText);
					elDiv.appendChild(elHeadSpan);
					elDiv.appendChild(elLink);
					// eElm.parentNode.insertBefore(elDiv, eElm.nextSibling); 
					eElm.parentNode.insertBefore(elDiv, eElm); 
				}
			}
		}
		catch(e) {
		}
	}
}

// [関数] スレッド内容の本文を再構築する(パースする)
function handleContentParser() {
	var eContent = document.getElementById("wr_content");
	var sContent = eContent.value;
	var parser = new DOMParser();
	var doc = parser.parseFromString(sContent, "text/html");
	eContent.value = doc.body.innerHTML;

}

// [関数] スレッド内容送信ボタンの介入をセット
function CheckInWriteSubmit() {
	var eSubmit = document.getElementById("write_submit");
	if (eSubmit) {
		eSubmit.addEventListener("click", handleContentParser);
	}
}