// *************************************************************************
// [内容] よく使う共通関数群。
// [詳細] 同上。
// *************************************************************************

// [関数] ニックネーム・ユーザーID混在リスト文字列を各タイプの配列として返す
function SplitIDCtrlList(lists) {
	
	// var ary = new Array();
	var l = lists.length;
	var dash = false;
	var regular = false;
	var idflag = false;
	var record = "";

	var aryUsernameRegular=[];
	var aryUsername=[];
	var aryUserid=[];

	for (var i = 0; i < l; i++) {
		var c = lists.substr(i, 1);

		if (c == "`") {	// 正規表現方式のニックネーム記述の可能性
			if (idflag) {
				// ID表記の解析中 (※普通ありえないので、このリストは壊れている?)
				continue;
			}
			if (dash) {
				// 完全一致方式ニックネーム内なので抜ける
			}
			else
			if(regular) {
				// 正規表現方式のニックネームを解析中なので、これは終了記号
				regular=false;
				aryUsernameRegular.push(record);
				record = "";
				continue
			}
			else {
				// 正規表現方式のニックネーム表記が開始された
				regular=true;
				continue
			}
		}
		
		if (c == "\"") { // 完全一致方式のニックネーム記述の可能性
			if (idflag) {
				// ID表記の解析中 (※普通ありえないので、このリストは壊れている?)
				continue;
			}
			if (regular) {
				// 正規表現方式のニックネームを解析中なので、抜ける
			}
			else
			if (dash) {
				// end dash
				dash = false;
				// if (record != "") {
				aryUsername.push(record);
				record = "";
				// }
				continue;
			} else {
				// begin dash
				dash = true;
				continue;
			}
		} else
		if (!dash && !regular && c == " ") {
			if (record != "") {
				if (idflag) {
					idflag = false;
					aryUserid.push(record);
				} else {
					// 完全一致方式のニックネーム表記が空白記号で終了
					aryUsername.push(record);
				}
				record = "";
			}
			continue;
		} else {
			if (record == "" && !dash && !regular && c == '#') {
				// IDが開始される
				idflag = true;
				continue;
			}
			record = record + "" + c;
		}
	}
	
	if (record != "") {
		if (idflag) {
			idflag = false;
			aryUserid.push(record);
		} else {
			if( !dash && !regular ) {
				// 完全一致方式のニックネーム表記が空白記号で終了
				aryUsername.push(record);
			}
		}
		record = "";
	}

	return { usernameRegular: aryUsernameRegular, username: aryUsername, userid: aryUserid };
}

// [関数] ニックネーム・ユーザーID混在リスト文字列を項目ごとに分割し、正規表現ニックネームリストのみ配列で返す。ダブルコーテーションを考慮する。
function SplitListRegularNickname(lists) {
	var arys=SplitIDCtrlList(lists);
	return arys.usernameRegular;
}

// [関数] ニックネーム・ユーザーID混在リスト文字列を項目ごとに分割し、完全一致ニックネームリストのみ配列で返す。ダブルコーテーションを考慮する。
function SplitListNickname(lists) {
	var arys=SplitIDCtrlList(lists);
	return arys.username;
}

// [関数] ニックネーム・ユーザーID混在リスト文字列を項目ごとに分割し、ユーザーIDリストのみ配列で返す。ダブルコーテーションを考慮する。
function SplitListUserid(lists) {
	var arys=SplitIDCtrlList(lists);
	return arys.userid;
}

// [関数] KJCLUB特有のスクリプトコードからユーザーIDのテキストを抽出する。(2023/4/19からはID検出不能)
function ScriptedCodeToUserid(s) {
	if (s) {
		lastPointedUser.log = "onclick発見";
		// var result = (s.match(/^javascript:showSideView\(this,\s*\'(\w*)\'/) || [])[1]; // ～2023/3/28までのKJ
		// var result = (s.match(/^javascript:showSideView\(this,\s*\'(\w*)\'\s*,\s*\'(\w*)\'/) || [])[2]; // 2023/3/30からのKJ
		var result = (s.match(/^javascript:showSideView\(this,\s*\'(.*)\'\s*,\s*(\")/) || [])[2]; // 2023/4/19 11:58:14のKJ改訂対応
		if (result != undefined) {
			return '';
			// return result;
		}
	}

	return null;
}