// *************************************************************************
// [内容] 掲示板介入 content_scripts スクリプト。
// [詳細] ページ上で右クリックを押したときに、直下のKJCLUBのIDを読み取る
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [定義] 読み取るエレメント。
var lastPointedUser = {
	userid: null,
	username: null
};

// [実行] マウスダウンやタップのイベントから呼ばれる
function Event(el) {

	lastPointedUser.userid = null;
	lastPointedUser.username = null;
	try {
		var count = 10;
		while (el && el.localName != "a" && count-- >= 0) {
			el = el.parentNode;
		}

		if (count >= 0) {
			if (el) {
				var s = el.getAttribute("onclick");
				var h = el.getAttribute("href");
				if (h == "javascript:;") {
					var elSs = el.getElementsByTagName("strong");
					if (elSs.length >= 1) {
						lastPointedUser.userid = ScriptedCodeToUserid(s);
						if (lastPointedUser.userid != null) {
							lastPointedUser.userid = null; // 2023/04/19 KJはuseridの露出を無効化
							// lastPointedUser.username = elSs[0].textContent.trim();
							lastPointedUser.username = elSs[0].textContent;
						}
					}
				}
			}
		}
	}
	catch(e) {
	}

	browser.runtime.sendMessage({
			request: "contextMenusUpdate",
			userid: lastPointedUser.userid,
			username: lastPointedUser.username
		},
		function(resp) {}
	);

	return true;
}

// [実行] マウスボタン押下をトリガーにして施術を実施するイベントリスナ。
function onMousedownEL(event) {
	if (event.button == 2 || event.button == 0) {
		//右クリックを検出
		var el = event.target;
		Event(el);
	}
	return true;
}

// [イベント受信関数] アンロード
function onElementReaderUnload() {
	document.removeEventListener("mousedown", onMousedownEL, true);
}

// [イベント受信関数] ロード
function onElementReaderLoad() {
	// アンロードイベントを登録する
	window.addEventListener('pagehide', onElementReaderUnload, { once: true });

	// [イベントリスナ登録] マウスボタン押下をトリガーにして施術を実施するイベントリスナ。
	document.addEventListener("mousedown", onMousedownEL, true);
}

// ロード時に呼ばれるイベントを登録
document.addEventListener("DOMContentLoaded", onElementReaderLoad );