/* */
function textSelect(obj) {
	var range, sel;
	if (window.getSelection) {
		range = document.createRange();
		range.setStart(obj.firstChild, 0);
		range.setEnd(obj.firstChild, obj.firstChild.nodeValue.length);
		sel = getSelection();
		sel.removeAllRanges();
		sel.addRange(range);
	}
}

/* コメントエリアを修繕する再帰関数 */
function rebuildComment(dataHTMLSrc) {
	let ctlid=dataHTMLSrc.length;
	let d = String(dataHTMLSrc);
	try {
		// コメントレコード修繕処理
		let d1 = d.search(/<a name="c_\d+"><\/a>/);
		if (d1 >= 0) {
			let name = d.substr(d1).match(/\d+/);
			let d2 = d.lastIndexOf('<span id="edit_' + name + '"');
			if (d2 > d1) {
				let d3 = d.indexOf('<div class="panel-body">', d1);
				if (d3 < 0) {
					return d;
				}
				let d4 = d.indexOf('>', d3) + ('>'.length); // 原文コメントレコードの頭の部分に到達
				if (d4 < 0) {
					return d;
				}
				let d5 = d.lastIndexOf('</div>', d2-1);
				if (d5 < 0) {
					return d;
				}
				let d6 = d.lastIndexOf('</div>', d5-1);　 // 翻訳文コメントレコードの尻の部分に到達
				if (d6 < 0) {
					return d;
				}
				let d7 = d.lastIndexOf('<div id="write_comment_trans_', d6-1);
				if (d7 < 0) {
					return d;
				}
				let d8 = d.lastIndexOf('</div>', d7-1); // 原文コメントレコードの尻の部分に到達
				if (d8 < 0) {
					return d;
				}
				let d9 = d.indexOf('>', d7) + ('>'.length);　 // 翻訳文コメントレコードの頭の部分に到達
				if (d9 < 0) {
					return d;
				}

				let parser = new DOMParser();
				var s = new XMLSerializer();

				let ary = [];

				// 前文
				let r0 = d.substring(0, d4);
				ary.push(r0);

				// 原文
				let r1 = '<div xmlns="http://www.w3.org/1999/xhtml" class="kjp-cmnt-src">' + d.substring(d4, d8).trim() + '</div>';

				// コメントの迷惑行為をチェック
				let p1DOM = parser.parseFromString(r1, "text/html");
				let eCBody = p1DOM.scrollingElement.firstChild;
				var hidden = false;

				// const startTime = performance.now(); // 開始時間

				// 迷惑行為検出: 文字出現の標準偏差
				if( !hidden ) {
					let str = eCBody.textContent;
					str = str.replace(/\s+/g,'');
					// console.log( str.length );
					// console.log( str );
					if( str.length >= 100 ) {
						var chars=[];
						var counts=0;
						let pos = str.length-1;
						while (pos !== -1) {
							let c = str.substr( pos, 1 );
							if( !chars[c] ) { chars[c]=1; }
							else { chars[c]++; }
							counts++;
							pos--;
						}
						
						let array = []
						for (key in chars) {
							// console.log('key:' + key + ' count:' + chars[key] );
							array.push( chars[key] );
						}
						
						const average = array.reduce((previous, current) =>
						    previous + current  // 要素をすべて足す
						) / array.length;  // 平均を求める
						const standardDeviation = Math.sqrt(  // 分散の平方根を求める
						    array.map((current) => {  // 各要素について
						        let difference = current - average;  // 平均値との差を求める
						        return difference ** 2;  // 差を2乘する
						    })
						    .reduce((previous, current) =>
						        previous + current  // 差の2乗をすべて足す
						    ) / array.length  // 差の2乗の平均が分散
						);

						// console.log("全有効文字数:" + counts + " 標準偏差:"+standardDeviation);
						
						if( standardDeviation >= 200 || standardDeviation == 0 ) {

							let lv = Math.floor( standardDeviation );
							let message = "明らかに迷惑な偏りがあるので除去しました。";
							if( lv >= 1 ) {
								// message = message + "(必死度"+Math.floor(standardDeviation)+")";
							}
							let elDiv = document.createElement('div');
							let elSpan = document.createElement('div');
							elSpan.classList.add('kjp-remove-reason');
							let elText = document.createTextNode( message );
							elSpan.appendChild(elText);
							elDiv.appendChild(elSpan);

							let sid="ejpx-"+ctlid;
							elSpan.style.cursor="pointer";
							elSpan.setAttribute("onclick","let el=document.getElementById('"+sid+"'); el.style.display=(el.style.display=='none' ? '' : 'none');");

							// 隠す元構造を格納するDIVを作って格納
							let elBody = document.createElement('div');
							elBody.setAttribute("data-filted",true);
							elBody.setAttribute("id",sid);
							elBody.style.border="1px dotted gray";
							elBody.style.display="none";
							elBody.appendChild(eCBody);

							// 構造を修正する
							elDiv.insertBefore(elBody,elSpan.nextSibling);
							p1DOM.scrollingElement.appendChild(elDiv);
							eCBody = p1DOM.scrollingElement.firstChild;

							ctlid++;
							
							hidden = true;
						}
					}
				}
				
				// 迷惑行為検出: 連続改行チェック
				if( !hidden ) {
					try {
						let s1 = eCBody.textContent;
						let s2=s1.replace(/=/g,'A').replace(/\S{,5}\n/g,'\n').replace(/\n/g,'=').replace(/\s+/g,'');
						if( s2.match(/={35,}/g) )	{
							
							let elDiv = document.createElement('div');
							let elSpan = document.createElement('div');
							elSpan.classList.add('kjp-remove-reason');
							let elText = document.createTextNode("明らかに迷惑な過剰改行があるので除去しました。");
							elSpan.appendChild(elText);
							elDiv.appendChild(elSpan);

							let sid="ejpx-"+ctlid;
							elSpan.style.cursor="pointer";
							elSpan.setAttribute("onclick","let el=document.getElementById('"+sid+"'); el.style.display=(el.style.display=='none' ? '' : 'none');");

							// 隠す元構造を格納するDIVを作って格納
							let elBody = document.createElement('div');
							elBody.setAttribute("data-filted",true);
							elBody.setAttribute("id",sid);
							elBody.style.border="1px dotted gray";
							elBody.style.display="none";
							elBody.appendChild(eCBody);

							// 構造を修正する
							elDiv.insertBefore(elBody,elSpan.nextSibling);
							p1DOM.scrollingElement.appendChild(elDiv);
							eCBody = p1DOM.scrollingElement.firstChild;

							ctlid++;

							hidden = true;
						}
					}
					catch(e) {
					}
				}
				
				// 迷惑行為検出: 巨大なheight属性
				if( !hidden ) {
					try {
						for (let eElm of eCBody.querySelectorAll('*[height]') ) {
							try {
								if( eElm.getAttribute("data-filted") ) {
									continue;
								}
								let height=Number(eElm.height);
								if( height && height > 2048 ) {
									let elDiv = document.createElement('span');
									elDiv.classList.add('kjp-remove-reason');
									let elText = document.createTextNode("明らかに迷惑な<"+eElm.tagName+">を除去しました。");
									elDiv.appendChild(elText);

									let sid="ejpx-"+ctlid;
									elDiv.style.cursor="pointer";
									elDiv.setAttribute("onclick","let el=document.getElementById('"+sid+"'); el.style.display=(el.style.display=='none' ? '' : 'none');");
										
									eElm.parentNode.insertBefore(elDiv, eElm); 

									// 元要素は削除せずに表示から消し、クリックで再表示可能にする。
									eElm.setAttribute("data-filted",true);
									eElm.setAttribute("id",sid);
									eElm.style.display="none";
									ctlid++;
								}
							}
							catch(e) {
							}
						}
					}
					catch(e) {
					}
				}
				
				// 迷惑行為検出: 巨大なwidth属性
				if( !hidden ) {
					try {
						for (let eElm of eCBody.querySelectorAll('*[width]') ) {
							try {
								let width=Number(eElm.width);
								if( eElm.getAttribute("data-filted") ) {
									continue;
								}
								if( width && width > 2048 ) {
									let elDiv = document.createElement('span');
									elDiv.classList.add('kjp-remove-reason');
									let elText = document.createTextNode("明らかに迷惑な<"+eElm.tagName+">を除去しました。");
									elDiv.appendChild(elText);

									let sid="ejpx-"+ctlid;
									elDiv.style.cursor="pointer";
									elDiv.setAttribute("onclick","let el=document.getElementById('"+sid+"'); el.style.display=(el.style.display=='none' ? '' : 'none');");

									eElm.parentNode.insertBefore(elDiv, eElm); 

									// 元要素は削除せずに表示から消し、クリックで再表示可能にする。
									eElm.setAttribute("data-filted",true);
									eElm.setAttribute("id",sid);
									eElm.style.display="none";
									ctlid++;
								}
							}
							catch(e) {
							}
						}
					}
					catch(e) {
					}
				}
				
				// const endTime = performance.now(); // 終了時間
				// console.log("処理時間:" + (endTime - startTime) + "ms");
				
				let p1 = s.serializeToString(eCBody);
				ary.push(p1);

				/*
				console.log( "原文→"+r1.length+" 修繕後→"+p1.length );
				if( r1.length != p1.length ) {
					console.log("◆原文レコード "+d4+" ～ "+d8);
					console.log( r1 );
					console.log("◆原文レコード(修繕後)");
					console.log( p1 );
				}
				*/

				// 中間分
				let r2 = d.substring(d8, d9);
				ary.push(r2);

				// 翻訳文
				let r3 = '<span xmlns="http://www.w3.org/1999/xhtml" class="kjp-cmnt-trans">' + d.substring(d9, d6).trim() + '</span>';

				let p3DOM = parser.parseFromString(r3, "text/html");
				let p3 = s.serializeToString(p3DOM.scrollingElement.firstChild);

				ary.push(p3);

				// 後文
				let nextData = d.substring(d6);

				// 後文部分を再帰呼び出しでリビルドする
				let r4 = rebuildComment(nextData);

				if (r4 != null) {
					ary.push(r4);
				}

				return ary.join("");
			}
		}
	} catch (e) {
		console.log("$.html override: error : "+e);
	}
	return d;
}

/* コメントハッキング対策のため、 jQueryの .html() 関数をオーバーライド */
var orgHtml = $.fn.html;
$.fn.html = function() {
	if (typeof arguments[0] == "string") {
		// console.log("$.html override: arg[0] is string");
		var dataHTMLSrc = arguments[0];

		if (dataHTMLSrc.indexOf('<form name="fdelcomment" ') == 0) {
			// 介入処理対象であることを確認

			// 壊れた文字を削除
			// console.log("■　ソース");
			// console.log("前 "+dataHTMLSrc.length+"文字");
			// dataHTMLSrc = dataHTMLSrc.replace(/[\ufffd\u0000]/g,'');
			// console.log("後 "+dataHTMLSrc.length+"文字");
			// console.log(dataHTMLSrc.encodeHexNumReg());
			// console.log(dataHTMLSrc);

			// コメント領域のリビルド
			var rebuild = rebuildComment(dataHTMLSrc)

			arguments[0] = rebuild;

			// dataHTMLSrc=removeTag(dataHTMLSrc,['a','form','input','button','ul','li','span','div','p','img','iframe','font','b','strong','i','s','br','textarea','script']);
		}
	}
	var result = orgHtml.apply(this, arguments);
	return result;
};