// *************************************************************************
// [内容] 掲示板介入 content_scripts スクリプト。
// [詳細] 掲示板への各種施術を実現するためのメインスクリプト。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [フラグ]
var fExtraView = false;
var getDevice = 'other';
var found = false;

try {
	// console.log( "location.href="+location.href );
	
	getDevice = (function() {
		var ua = navigator.userAgent;
		if (ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0) {
			return 'sp';
		} else if (ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0) {
			return 'tab';
		} else {
			return 'other';
		}
	})();
	
	if (getDevice == "sp" || getDevice == "tab") {
		// [対象外] 介入対象外のブラウザ
	} else {
		// [審査] 介入対象のURLであることを確認。
		var str = location.href;
		var re1 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+$/i;
		var re2 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\?/i;
		var re3 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists$/i;
		var re4 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\?/i;
		var re5 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\/page\/\d+$/i;
		var re6 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\/page\/\d+\?/i;
		var re7 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\/id\/\d+$/i;
		var re8 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\/id\/\d+\/page\/\d+$/i;
		var re9 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/lists\/id\/\d+\/page\/\d+?/i;
		var re10 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/view\/id\/\d+$/i;
		var re11 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/view\/id\/\d+\?/i;
		var re12 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/view\/id\/\d+\/page\/\d+$/i;
		var re13 = /^https?:\/\/www\.kjclub\.com\/(jp|kr)\/board\/exc_board_\d+\/view\/id\/\d+\/page\/\d+\?/i;
		
		found = re1.test(str) || 
			re2.test(str) ||
			re3.test(str) ||
			re4.test(str) ||
			re5.test(str) ||
			re6.test(str) ||
			re7.test(str) ||
			re8.test(str) ||
			re9.test(str) ||
			re10.test(str) ||
			re11.test(str) ||
			re12.test(str) ||
			re13.test(str);

		if (found) {
			// アンロードイベントを登録する
			window.addEventListener('pagehide', onLayoutUnload, { once: true });

			// [実行] ストレージデータ獲得成功をトリガーにして施術を実施する。
			browser.runtime.sendMessage({
					request: "getExtraView"
				},
				function(resp) {
					fExtraView = DFProf( "kjclub_extraview", resp.extraview );
					if (fExtraView) {
						ExtraView();
					}
					// [監視開始] ストレージ変化を監視し介入を動的に実行する
					browser.storage.onChanged.addListener(onLayoutStorageChanged);
				}
			);
		}
	}
}
catch(e) {
}

// [イベント受信関数] アンロードイベント
function onLayoutUnload() {
	browser.storage.onChanged.removeListener( onLayoutStorageChanged );
}

// [イベント受信関数] ストレージ変化時の動的介入
function onLayoutStorageChanged(changes, namespace) {
	if (namespace == "local") {
		if (changes.kjclub_extraview) {
			try {
				fExtraView = changes.kjclub_extraview.newValue;
				ExtraView();
			}
			catch(e) {
			}
		}
	}
}

// [関数] ExtraViewのCSSを挿入する
function ExtraView() {
	try {
		if (fExtraView) {
			var linkElement = document.createElement('link');
			linkElement.setAttribute('rel', "stylesheet");
			linkElement.setAttribute('href', browser.extension.getURL("KJExtraView/layout.css")); // Self script only.
			document.documentElement.appendChild(linkElement);
		} else {
			document.location.reload(false);
		}
	}
	catch(e) {
	}
}