// *************************************************************************
// [内容] サイドバーパネルのメインスクリプト。
// [詳細] サイドバーパネル機能を充実させる関数群とメインスクリプト。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [フラグ]
var fSide="jp";
var fSecure=false;
var fExtraView=false;
// var fExtraViewSidebarNavigation=false;
var aryBoardsInfo=[];
var BeforeBoardInfoText=""; // DOM更新低減のために保持する前回のボードテキストデータ。


// [関数] KJCLUBカテゴリーのリンクを応答する。
function getLink(service, recs, secure) {
	// var kjclubScheme = secure ? "https" : "http";
	var kjclubScheme = "https"; // 2020/1/25 https enabled (2017/4/20 KJCLUB disabled https access.)

	switch (service) {
		case "kjclub:jp":
			http: //www.kjclub.com/jp/board/exc_board_9
				return kjclubScheme + "://www.kjclub.com/jp/board/exc_board_" + recs["id"];
		case "kjclub:kr":
			return kjclubScheme + "://www.kjclub.com/kr/board/exc_board_" + recs["id"];
	}
	return "";
}

// [関数] サイドバーのKJCLUB各カテゴリーへのリンクを構築し、挿入する。
function loadCategoriesKjclub(Panel, service, cats) {
	var fStripe = false;
	Panel.innerHTML = "";
	var side=fSide;
	var secure=fSecure;

	/*
	if(!AMO) {
		if( fExtraView && fExtraViewSidebarNavigation ) {
			document.getElementById("kjclub_tab_frame").style.display="inline-block";
		}
		else {
			document.getElementById("kjclub_tab_frame").style.display="none";
			document.getElementById("tab1").checked=true;
		}
	}
	*/
	
	for (var i in cats) {
		var recs = cats[i];

		// i18n (多言語対応)
		if (recs["i18n"]) {
			recs["title"] = i18n(recs["i18n"], recs["title"]);
		}

		var elDiv = document.createElement("div");
		
		if (recs["m"] == "*section") {
			fStripe = false;
			elDiv.className = "record_section";

			var elTEXT = document.createTextNode(recs["title"] + " ► ");
			elDiv.appendChild(elTEXT);
		} else
		if (recs["m"] == "*subsection") {
			fStripe = false;
			elDiv.className = "record_subsection";
			var elTEXT = document.createTextNode(recs["title"]);
			elDiv.appendChild(elTEXT);
		} else {
			var cls="record " + (fStripe ? "stripe2" : "stripe1");
			if(recs["id"]>=1) {
				cls=cls+" board_"+recs["id"];
			}
			elDiv.className = cls;
			var elA = document.createElement("a");
			elA.href = getLink(service + ":" + side, recs, secure);
			
			elA.target = "_main";
			
			/*
			if(!AMO) {
				if( fExtraView && fExtraViewSidebarNavigation ) {
					elA.target = "kjclub_frame";
					// クリックイベントを割り当てる
					elA.addEventListener("click", onClickKJCLUBCategory);
					elA.href=elA.href+"#bo_list_writes";
				}
			}
			*/

			var elTEXT = document.createTextNode(recs["title"]);
			elA.appendChild(elTEXT);
			elDiv.appendChild(elA);

			// カテゴリー情報を追加。
			var board=recs["id"];
			
			for(var i=0; i<aryBoardsInfo.length; i++) {
				var aryBRec=aryBoardsInfo[i];
				if( aryBRec.board==board ) {
					// FOUND
					var changed=false;
					var hot=aryBRec.hot;
					var threads=aryBRec.threads;
					var elBadge = document.createElement("span");
					var cls="badge";
					if(hot) {
						cls=cls+" new";
					}
					if(changed) {
						cls=cls+" blinking";
					}
					elBadge.className=cls;
					var elBadgeText = document.createTextNode(threads);
					elBadge.appendChild(elBadgeText);
					elDiv.appendChild(elBadge);
					break;
				}
			}

			fStripe = fStripe ? false : true;
		}

		Panel.appendChild(elDiv);
	}
}

// [関数] 掲示板カテゴリー情報のテキストを配列に変換して保持する
function BuildBoardInfo(boardInfoText) {
	if(boardInfoText=="" || BeforeBoardInfoText==boardInfoText ) {
		// 更新しない。
		return;
	}
	BeforeBoardInfoText=boardInfoText; // DOM更新削減のため前回データとして保持する。
	aryBoardsInfo=[];
	var aryRecords=boardInfoText.split(":");
	for(var i=0;i<aryRecords.length;i++) {
		var aryThis=aryRecords[i].split(",");
		var board=aryThis[0];
		var threads=aryThis[1];
		var hot=aryThis[2];
		if( !isNaN(board) & !isNaN(threads) & !isNaN(hot) ) {
			// 全て数字なので有効なデータ
			var ary={
				board: board,
				threads: threads,
				hot: hot==1 ? true : false
			}
			aryBoardsInfo.push(ary);
		}
	}
}

// [関数] 掲示板カテゴリー情報配列をカテゴリーリスト表示に反映させる。
function UpdateBoardInfo() {
	var elPanel=document.getElementById("panel_kjclub_list");

	for(var i=0; i<aryBoardsInfo.length; i++) {
		var aryBRec=aryBoardsInfo[i];
		var board=aryBRec["board"];
		var hot=aryBRec["hot"];
		var threads=aryBRec["threads"];
		var elCs=elPanel.getElementsByClassName("board_"+board);
		if(elCs && elCs.length>=1) {
			// FOUND
			var elC=elCs[0];
			var elBadges=elC.getElementsByClassName("badge");
			if(elBadges && elBadges.length>=1) {
				// 既にバッジが存在している
				var elBadge=elBadges[0];
				var changed=false;
				var oldThreads=elBadge.textContent;
				if(oldThreads && oldThreads!=threads) {
					changed=true;
				}
				var cls="badge";
				if(hot) {
					cls=cls+" new";
				}
				if(changed) {
					cls=cls+" blinking";
				}
				elBadge.className=cls;
				elBadge.textContent=threads;
			}
			else {
				// 新規作成が必要
				var elBadge = document.createElement("span");
				var cls="badge";
				if(hot) {
					cls=cls+" new";
				}
				elBadge.className=cls;
				var elBadgeText = document.createTextNode(aryBRec.threads);
				elBadge.appendChild(elBadgeText);
				elC.appendChild(elBadge);
				elC.className=elC.className+" board_"+board;
			}
		}
	}
}

// [関数] 多言語対応のためのキー定義と、書き換え実施。
function i18nRInTextsPanelKjclub() {
	document.title=i18n("KJPlusExtensionName", "KJCLUB Categories List");
	// 言語介入の実行。
	i18nHtml();
}

// [関数] サイドバーパネルのロード完了イベント時にコールされる。
function kjclub() {
	// [イベントリスナ登録] ログインボタンにイベントを割り当てる
	document.getElementById("kjclub_login").addEventListener("click", onClickKJCLUBLogin);
	// [イベントリスナ登録] 掲示板タブダブルクリック時のイベント
	document.getElementById("kjclub_tab_categories").addEventListener("dblclick", defaultToKJCLUBBBS, false);
	// [イベントリスナ登録] チャットタブクリック時のイベント
	document.getElementById("tab2").addEventListener("change", onActiveKJCLUBChats);
	// [イベントリスナ登録] メル友タブクリック時のイベント
	document.getElementById("tab3").addEventListener("change", onActiveKJCLUBFriends);
}

// [イベント受信関数] onClickKJCLUBChats
function onActiveKJCLUBChats() {
	if( document.getElementById("tab2").checked==true ) {
		document.getElementById("tab2").removeEventListener("change", onActiveKJCLUBChats, false);
		defaultToKJCLUBChats();
		document.getElementById("kjclub_tab_frame").title="ダブルクリックで翻訳チャットのトップに再接続します。";
		document.getElementById("kjclub_tab_frame").addEventListener("dblclick", defaultToKJCLUBChatsWithWait, false);
	}
}
// [関数] デフォルトのURLにジャンプさせる
function defaultToKJCLUBBBS() {
	var side = fSide=="kr" ? "kr" : "jp";
	browser.tabs.update({url:"https://www.kjclub.com/"+side+"/board"}); 
}
// [関数] デフォルトのURLにジャンプさせる
function defaultToKJCLUBChatsWithWait() {
	// document.kjclub_frame.location.href="about:blank";
	document.getElementById("kjclub_frame").contentWindow.location.replace("about:blank");
	setTimeout(defaultToKJCLUBChats,1000);
}
function defaultToKJCLUBChats() {
	var side = fSide=="kr" ? "kr" : "jp";
	// document.getElementById("kjclub_frame").setAttribute("src","http://www.kjclub.com/"+side+"/openchat");
	// document.kjclub_frame.location.href="http://www.kjclub.com/"+side+"/openchat";
	document.getElementById("kjclub_frame").contentWindow.location.replace("https://www.kjclub.com/"+side+"/openchat");
}
// [イベント受信関数] onClickKJCLUBChats
function onActiveKJCLUBFriends() {
	if( document.getElementById("tab3").checked==true ) {
		document.getElementById("tab3").removeEventListener("change", onActiveKJCLUBChats, false);
		defaultToKJCLUBFriends();
		document.getElementById("kjclub_tab_friends").title="ダブルクリックでメル友のトップに再接続します。";
		document.getElementById("kjclub_tab_friends").addEventListener("dblclick", defaultToKJCLUBFriendsWithWait, false);
	}
}
// [関数] デフォルトのURLにジャンプさせる
function defaultToKJCLUBFriendsWithWait() {
	// document.kjclub_friends_frame.location.href="about:blank";
	document.getElementById("kjclub_friends_frame").contentWindow.location.replace("about:blank");
	setTimeout(defaultToKJCLUBFriends,1000);
}
function defaultToKJCLUBFriends() {
	var side = fSide=="kr" ? "kr" : "jp";
	// document.getElementById("kjclub_friends_frame").setAttribute("src","http://www.kjclub.com/"+side+"/friends");
	// document.kjclub_friends_frame.location.href="http://www.kjclub.com/"+side+"/friends";
	document.getElementById("kjclub_friends_frame").contentWindow.location.replace("https://www.kjclub.com/"+side+"/friends");
}
// [イベント受信関数] onClickKJCLUBCategory
/*
function onClickKJCLUBCategory(e) {
	// e.preventDefault();
	var elFrame=document.getElementById("tab2");
	elFrame.checked=true;
}
*/
// [イベント受信関数] onClickKJCLUBLogin
function onClickKJCLUBLogin(e) {
	// ブラウザに保存されたログイン情報をロードする
	browser.storage.local.get(
		[
			"kjclub_login_id", "kjclub_login_pass"
		],

		(res) => {
			document.forms["flogin"].mb_id.value = DFProf( "kjclub_login_id", res.kjclub_login_id );
			document.forms["flogin"].mb_password.value = DFProf( "kjclub_login_pass", res.kjclub_login_pass );
			if (document.forms["flogin"].mb_id.value == "" || document.forms["flogin"].mb_password.value == "") {
				// [警告] IDとパスワードが設定されていない旨を通知。
				document.getElementById("kjclub_login").textContent = i18n("kjclub_login_blankaccount", "オプション設定でKJCLUBのログイン情報を設定して下さい。");
				setTimeout(onTimerAfterKJCLUBLogin, 5000);
				return;
			}
			document.getElementById("kjclub_login").textContent = i18n("kjclub_login_sended", "ログインを送信しました");
			document.forms["flogin"].submit();
			setTimeout(onTimerAfterKJCLUBLogin, 5000);
		}
	);
}

// [イベント受信関数] ログイン後のメッセージ復帰
function onTimerAfterKJCLUBLogin() {
	document.getElementById("kjclub_login").textContent = i18n("kjclub_login", "✔ ログイン");
}

// [イベント受信関数] サイドバーパネルのロード完了イベント時にコールされる。
function StartKjclub() {
	i18nRInTextsPanelKjclub();
	// "kjclub_extraview_sidebar_navigation"
	browser.storage.local.get(
		["kjclub_side", "kjclub_secure","kjclub_boardsinfo","kjclub_extraview"],
		
		(res) => {
			fSecure = DFProf( "kjclub_secure", res.kjclub_secure );
			fSide = DFProf( "kjclub_side", res.kjclub_side );
			if(!AMO) {
				fExtraView = DFProf( "kjclub_extraview", res.kjclub_extraview );
				// fExtraViewSidebarNavigation = res.kjclub_extraview_sidebar_navigation == "1" ? true : false;
			}
			var boardInfoText=res.kjclub_boardsinfo == undefined ? "" : res.kjclub_boardsinfo;
			BuildBoardInfo(boardInfoText);
			// カテゴリーリストのHTMLを構築し挿入
			loadCategoriesKjclub(document.getElementById("panel_kjclub_list"), "kjclub", KJCategories);
			// [ストレージ監視開始] ストレージ変化(セキュアとアクセスサイド)を監視し、変化したら再構築させる。
			browser.storage.onChanged.addListener(onStorageChanged);
		}
	);

	kjclub();
}

// [イベント受信関数] ストレージ変化時の動的介入
function onStorageChanged(changes, namespace) {
	var fKJCLUBCategoriesRebuild = false;
	if (namespace == "local") {
		if(changes.kjclub_secure) {
			fKJCLUBCategoriesRebuild = true;
			fSecure = changes.kjclub_secure.newValue;
		}
		if(changes.kjclub_side) {
			fKJCLUBCategoriesRebuild = true;
			fSide = changes.kjclub_side.newValue;
		}
		if(!AMO) {
			if(changes.kjclub_extraview) {
				fKJCLUBCategoriesRebuild = true;
				fExtraView = changes.kjclub_extraview.newValue;
			}
			/*
			if(changes.kjclub_extraview_sidebar_navigation) {
				fKJCLUBCategoriesRebuild = true;
				fExtraViewSidebarNavigation = changes.kjclub_extraview_sidebar_navigation.newValue == "1" ? true : false;
			}
			*/
		}
		if(changes.kjclub_boardsinfo) {
			var boardInfoText=changes.kjclub_boardsinfo.newValue;
			BuildBoardInfo(boardInfoText);
			if(!fKJCLUBCategoriesRebuild) {
				UpdateBoardInfo();
			}
		}
	}
	if(fKJCLUBCategoriesRebuild) {
		// カテゴリーリストのHTMLを構築し挿入
		loadCategoriesKjclub(document.getElementById("panel_kjclub_list"), "kjclub", KJCategories);
	}
}

// [イベントリスナ登録] サイドバーパネルのロード完了イベントを受けて介入を実施する。
document.addEventListener("DOMContentLoaded", StartKjclub);