// *************************************************************************
// [内容] ログイン情報収得 content_scripts スクリプト。
// [詳細] ログイン情報収得を実現するためのメインスクリプト。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [関数] ログイン状態をチェックし、情報を獲得する。
function LoginChecker() { // getElementsByClassName("navbar").
	var login = {
		userid: null,
		username: null
	};

	// console.log("ページロード終了時の詳細チェッカ");
	try {
		// ログインIDを検出 ( クッキーの ドメイン: .kjclub.com 名前: kimemberid )
		var aryCookies = getCookies();
		if ("kimemberid" in aryCookies) {
			login.userid = aryCookies.kimemberid;
		}

		// ログインニックネームを検出(デスクトップ向けのKJCLUB表示)
		try {
			var elNavibars = document.getElementsByClassName("navbar navbar-default kj-top-menu");
			if (elNavibars.length >= 1) {
				var elNicknames = elNavibars[0].getElementsByClassName("glyphicon-user");
				if (elNicknames.length >= 1) {
					var elNickname = elNicknames[0].parentNode;
					login.username = elNickname.textContent.trim();
				}
			}
		}
		catch(e) {
			// ドキュメントがHTMLでない場合はエラー防止処置をとる
		}

		// ログインニックネームを検出(アンドロイド向けのKJCLUB表示)
		try {
			var elNavibar = document.getElementById("pnProductNavContents");
			if (elNavibar) {
				var elProdLinks = elNavibar.getElementsByClassName("pn-ProductNav_Link");
				var elMemberModify = elProdLinks[3];
				var sMMHref = elMemberModify.getAttribute("href");
				if (sMMHref && sMMHref.indexOf("member.modify") >= 0) {
					var elNickname = elProdLinks[2];
					if (elNickname) {
						login.username = elNickname.textContent.trim();
					}
				}
			}
		}
		catch(e) {
			// ドキュメントがHTMLでない場合はエラー防止処置をとる
		}

		browser.runtime.sendMessage({
				request: "setLoginIDInformation",
				userid: login.userid,
				username: login.username
			},
			function(resp) {}
		);
	}
	catch(e) {
		// エラー防止処置をとる
	}
}

LoginChecker(); // ログイン状態をチェックし情報を獲得する