// *************************************************************************
// [内容] 文字参照変換
// [詳細] 文字参照変換
// *************************************************************************

// [関数] 多言語対応のためのテキストキー定義と介入の実施を行う。
function i18nRInTextsCE() {
	/*
	// キーの定義。
	var i18nTexts = [
	];

	// document.title=i18n("sidebar_tab_options", "KJCLUB Plus+ Settings");

	// 介入の実行。
	for (var key of i18nTexts) {
		i18nRInText(key);
	}
	*/
}

// [関数] 数値文字参照変換関数
function DoUniTrans( s, vIndec)
{
	var EndCode=""; // 通常は ; だが、KJCLUBが破壊してしまうので、不正データ出力でブラウザの解釈機能に頼る。
	var conv="";
	var ascii_trans=false;
	var c=0;
	var sCVHead="&#x";
	
	try 
	{
		if( vIndec=="EU" )
		{
			// escaped-unicode (\u
			for(var i=0 ; i < s.length ; i++)
			{
				c=s.charCodeAt(i);
				if(c>=0x1000)
				{
					conv=conv+"\\u"+c.toString(16);
				}
				else
				if(c>=0x100)
				{
					conv=conv+"\\u0"+c.toString(16);
				}
				else
				if(c>=0x10)
				{
					conv=conv+"\\u00"+c.toString(16);
				}
				else
				{
					conv=conv+"\\u000"+c.toString(16);
				}
				
			}

			return conv;
		}
		
		if( vIndec!=16 )
		{
			sCVHead="&#";
			vIndec=10;
		}

		// html-unicode (&#x;
		
		for(var i=0 ; i < s.length ; i++)
		{
			c=s.charCodeAt(i);
			if ( c == 32 ) { conv=conv+" "; } // Not Translate: SPACE
			if ( c >= 0 && c<=0x7D ) { // ASCII Code (It doesn't convert it usually.)
				if( ascii_trans ) { conv=conv+sCVHead+c.toString(vIndec)+EndCode; }
				else	{
					if (c == "60" || c == "62") { conv=conv+sCVHead+c.toString(vIndec)+EndCode;  } // Translate: < or >
					else {conv=conv+s.charAt(i); }
				}
			}
			else {	// Translate
				conv=conv+sCVHead+c.toString(vIndec)+EndCode;
			}
		}
	
	} catch(e) { conv=""; }
	return conv;
}

// [イベント受信関数] 数値文字参照変換を実行するボタンが押されたときに呼ばれるイベント。
function onClickCEConert() {
	var elFrom=document.getElementById("ce_from");
	var elTo=document.getElementById("ce_to");
	
	var sSourceText=elFrom.value;
	
	var sTargetText=DoUniTrans( sSourceText, 16 ).trim()+" ";
	
	elTo.value=sTargetText;
	elTo.focus();
	elTo.select();
}

// [イベント受信関数] オプション設定文書のロード時に一度だけコールされる
function onLoadCE() {
	i18nRInTextsCE();

	// [イベントリスナ登録] クリックヘルプ(WHAT'S IT?)
	document.getElementById("helpbtn_ce_what").addEventListener("click", function(e) {
		document.getElementById("help_ce_what").style.display = document.getElementById("help_ce_what").style.display=="block" ? "none" : "block";
	});

	// [イベントリスナ登録] クリックヘルプ(HOW TO?)
	document.getElementById("helpbtn_ce_how").addEventListener("click", function(e) {
		document.getElementById("help_ce_how").style.display = document.getElementById("help_ce_how").style.display=="block" ? "none" : "block";
	});

	// [イベントリスナ登録] コンテンツロード時にonLoad()を呼ぶためのイベントリスナ登録を行う。
	document.getElementById("ce_convert_16").addEventListener("click", onClickCEConert);
}

// [イベントリスナ登録] コンテンツロード時にonLoad()を呼ぶためのイベントリスナ登録を行う。
document.addEventListener("DOMContentLoaded", onLoadCE);