// *************************************************************************
// [内容] バックグラウンド・スクリプト／コンテキストメニュー
// [詳細] コンテキストメニュー「強調」のコントロールを実施する
// [一時廃棄] 2023/04/19 17:58 - KJCLUBの仕様変更によりID指標が使用不能になったため(KJ側が元に戻す可能性があるためコードは残存)
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [関数] ユーザーIDリムーバーメニューの実行
function clickedMark(info, tab) {
	// browser.tabs.sendMessage(tab.id, "lastPointedUser", function(lastPointedUser) {
		if ( lastPointedUser != null ) {
			switchMark(lastPointedUser.userid, lastPointedUser.username);
		}
	// });
}

// [関数] 状態をセットする
function setMark(userid, username) {
	// フィルタリストの更新
	var aSlRegularNicknames = SplitListRegularNickname(strUserMarkingNicknames);
	var aSlNicknames = SplitListNickname(strUserMarkingNicknames);
	var aSlUserids = SplitListUserid(strUserMarkingNicknames);

	// この操作を実行した場合、ニックネーム設定が存在する場合はそれを除去する
	var resultName = aSlNicknames.indexOf(username);
	if (resultName >= 0) {
		aSlNicknames.splice(resultName, 1); // このIDをリストから削除
	}

	// ユーザーIDを検索する(本命)
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {} else {
		aSlUserids.unshift(userid); // このIDをリスト先頭に追加
		updateMarkStorage(aSlUserids, aSlNicknames, aSlRegularNicknames);
	}
}

// [関数] 状態を削除する
function deleteMark(userid, username) {
	// フィルタリストの更新
	var aSlRegularNicknames = SplitListRegularNickname(strUserMarkingNicknames);
	var aSlNicknames = SplitListNickname(strUserMarkingNicknames);
	var aSlUserids = SplitListUserid(strUserMarkingNicknames);

	// この操作を実行した場合、ニックネーム設定が存在する場合はそれを除去する
	var resultName = aSlNicknames.indexOf(username);
	if (resultName >= 0) {
		aSlNicknames.splice(resultName, 1); // このIDをリストから削除
	}

	// ユーザーIDを検索する(本命)
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {
		aSlUserids.splice(result, 1); // このIDをリストから削除
		updateMarkStorage(aSlUserids, aSlNicknames, aSlRegularNicknames);
	} else {}
}

// [関数] 状態をスイッチする
function switchMark(userid, username) {
	deleteRemove(userid, username); // この操作を実施するときは除去リストからIDを除去する
	var aSlUserids = SplitListUserid(strUserMarkingNicknames);
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {
		deleteMark(userid, username);
	} else {
		setMark(userid, username);
	}
}

// [関数] 状態をストレージに保存する
function updateMarkStorage(aSlUserids, aSlNicknames, aSlRegularNicknames) {
	var list = JoinListAry(aSlUserids, aSlNicknames, aSlRegularNicknames); // リスト文字列を再構築
	browser.storage.local.set({
		kjclub_usermarking_nicknames: list,
		kjclub_usermarking: true
	}, function() {});
}

// [右クリックしたときに開くコンテキストメニューを登録] 直接除去設定 (※Android版はcontextMenus非対応なのでtry～catchでくくる)

// console.log("ctxMenuMark contextMenus.create");

var cmiMark = null;
try {
	cmiMark = browser.contextMenus.create({
		title: i18n("optdirect_idctl_mark_contextMenus", "Hilight this KJCLUB User"),
		contexts: ["all"],
		type: "checkbox",
		documentUrlPatterns: ["*://www.kjclub.com/jp/board/exc_board_*", "*://www.kjclub.com/kr/board/exc_board_*"],
		onclick: clickedMark
	});
}
catch(e) {
}

// targetUrlPatterns: ["javascript:;"],

// [関数] ユーザーIDリムーバーメニューの表示更新
function updateMark(userid, username) {
	if( !cmiMark ) {
		return false;
	}
	var mOpt = null;
	try {
		if (userid != null || username != null) {
			// フィルタリストの更新
			var nicknames = strUserMarkingNicknames;
			var aSl = SplitListUserid(nicknames);
			var result = aSl.indexOf(userid);
			if (result >= 0) {
				// IDがリストに存在
				mOpt = {
					visible: true,
					checked: true
				};
			} else {
				// IDはリストに存在しない
				mOpt = {
					visible: true,
					checked: false
				};
			}
		} else {
			mOpt = {
				visible: false,
				checked: false
			};
		}
		if (mOpt != null) {
// console.log("ctxMenuMark contextMenus.update");
			browser.contextMenus.update(cmiMark, mOpt);
		}
	}
	catch(e) {
	}
	return mOpt ? mOpt.visible : false;
}