// *************************************************************************
// [内容] バックグラウンド・スクリプト／コンテキストメニュー
// [詳細] コンテキストメニュー「除去」のコントロールを実施する
// [一時廃棄] 2023/04/19 17:58 - KJCLUBの仕様変更によりID指標が使用不能になったため(KJ側が元に戻す可能性があるためコードは残存)
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [関数] ユーザーIDリムーバーメニューの実行
function clickedRemove(info, tab) {
	// browser.tabs.sendMessage(tab.id, "lastPointedUser", function(lastPointedUser) {
		if ( lastPointedUser.userid != null ) {
			switchRemove(lastPointedUser.userid, lastPointedUser.username);
		}
	// });
}

// [関数] 状態をセットする
function setRemove(userid, username) {
	// フィルタリストの更新
	var aSlRegularNicknames = SplitListRegularNickname(strUserFilteringNicknames);
	var aSlNicknames = SplitListNickname(strUserFilteringNicknames);
	var aSlUserids = SplitListUserid(strUserFilteringNicknames);

	// この操作を実行した場合、ニックネーム設定が存在する場合はそれを除去する
	var resultName = aSlNicknames.indexOf(username);
	if (resultName >= 0) {
		aSlNicknames.splice(resultName, 1); // このIDをリストから削除
	}

	// ユーザーIDを検索する(本命)
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {} else {
		aSlUserids.unshift(userid); // このIDをリスト先頭に追加
		updateRemoveStorage(aSlUserids, aSlNicknames, aSlRegularNicknames);
	}
}

// [関数] 状態を削除する
function deleteRemove(userid, username) {
	// フィルタリストの更新
	var aSlRegularNicknames = SplitListRegularNickname(strUserFilteringNicknames);
	var aSlNicknames = SplitListNickname(strUserFilteringNicknames);
	var aSlUserids = SplitListUserid(strUserFilteringNicknames);

	// この操作を実行した場合、ニックネーム設定が存在する場合はそれを除去する
	var resultName = aSlNicknames.indexOf(username);
	if (resultName >= 0) {
		aSlNicknames.splice(resultName, 1); // このIDをリストから削除
	}

	// ユーザーIDを検索する(本命)
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {
		aSlUserids.splice(result, 1); // このIDをリストから削除
		updateRemoveStorage(aSlUserids, aSlNicknames, aSlRegularNicknames);
	} else {}
}

// [関数] 状態をスイッチする
function switchRemove(userid, username) {
	deleteMark(userid, username); // この操作を実施するときは強調リストからIDを除去する
	var aSlUserids = SplitListUserid(strUserFilteringNicknames);
	var result = aSlUserids.indexOf(userid);
	if (result >= 0) {
		deleteRemove(userid, username);
	} else {
		setRemove(userid, username);
	}
}

// [関数] 状態をストレージに保存する
function updateRemoveStorage(aSlUserids, aSlNicknames, aSlRegularNicknames) {
	var list = JoinListAry(aSlUserids, aSlNicknames, aSlRegularNicknames); // リスト文字列を再構築
	browser.storage.local.set({
		kjclub_userfiltering_nicknames: list,
		kjclub_userfiltering: true
	}, function() {});
}

// [右クリックしたときに開くコンテキストメニューを登録] 直接除去設定 (※Android版はcontextMenus非対応なのでtry～catchでくくる)
var cmiRemove = null;
try {
	cmiRemove = browser.contextMenus.create({
		title: i18n("optdirect_idctl_remove_contextMenus", "Remove this KJCLUB User"),
		contexts: ["all"],
		type: "checkbox",
		documentUrlPatterns: ["*://www.kjclub.com/jp/board/exc_board_*", "*://www.kjclub.com/kr/board/exc_board_*"],
		onclick: clickedRemove
	});
}
catch(e) {
}

// targetUrlPatterns: ["javascript:;"],

// [関数] ユーザーIDリムーバーメニューの表示更新
function updateRemove(userid, username) {
	if( !cmiRemove ) {
		return false;
	}
	var mOpt = null;
	try {
		if (userid != null || username != null) {
			// フィルタリストの更新
			var nicknames = strUserFilteringNicknames;
			var aSl = SplitListUserid(nicknames);
			var result = aSl.indexOf(userid);
			if (result >= 0) {
				// IDがリストに存在
				mOpt = {
					visible: true,
					checked: true
				};
			} else {
				// IDはリストに存在しない
				mOpt = {
					visible: true,
					checked: false
				};
			}
		} else {
			mOpt = {
				visible: false,
				checked: false
			};
		}
		if (mOpt != null) {
			browser.contextMenus.update(cmiRemove, mOpt);
		}
	}
	catch(e) {
	}
	return mOpt ? mOpt.visible : false;
}