// *************************************************************************
// [内容] よく使う共通関数群。
// [詳細] 同上。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// リスト文字列を再構築
function JoinListAry(aSlUserid, aSlNicknames, aSlRegularNicknames) {
    var list = "";
    var Records = 0;

    for (var i = 0; i < aSlUserid.length; i++) {
        if (Records >= 1) {
            list = list + ' ';
        }
        var r = '#' + aSlUserid[i];
        if (r.length >= 2 && r.slice(0, 1) == '#') {
            // これはID
            list = list + r;
            Records++;
        } else {
            // ユーザーID形式以外は無効なので除去する
        }
    }

    for (var i = 0; i < aSlNicknames.length; i++) {
        if (Records >= 1) {
            list = list + ' ';
        }
        var r = aSlNicknames[i];
        list = list + '"' + r + '"';
        Records++;
    }

    for (var i = 0; i < aSlRegularNicknames.length; i++) {
        if (Records >= 1) {
            list = list + ' ';
        }
        var r = aSlRegularNicknames[i];
        list = list + '`' + r + '`';
        Records++;
    }

    return list;
}

// [関数] ページを開く(既に開いている場合はそのタブに切り替える)
function CreateUpdateTab(url) {
    var uri = browser.extension.getURL(url);

    browser.tabs.query({}, function(tabs) {
        var tabId = -1;
        if (tabs && tabs.length >= 1) {
            for (var i = tabs.length - 1; i >= 0; i--) {
                if (tabs[i].url === uri) {
                    tabId = tabs[i].id;
                    break;
                }
            }
        }

        if (tabId >= 0) {
            browser.tabs.update(tabId, {
                "active": true
            });
        } else {
            browser.tabs.create({
                "url": uri
            });
        }
    });

    return uri;
}

// [関数] POSTを実行する
function execPost(action, target, data) {
    var form = document.createElement("form");
    form.setAttribute("action", action);
    form.setAttribute("target", target);
    form.setAttribute("method", "post");
    form.style.display = "none";
    document.body.appendChild(form);
    var mes = "";
    if (data !== undefined) {
        for (var paramName in data) {
            var input = document.createElement('input');
            input.setAttribute('type', 'hidden');
            if (mes != "") {
                mes = mes + "&";
            }
            mes = mes + paramName + "=" + data[paramName];
            input.setAttribute('name', paramName);
            input.setAttribute('value', data[paramName]);
            form.appendChild(input);
        }
    }
    console.log(mes);
    form.submit();
}

// [関数] プロファイルの矯正
function DFProf(key, val) {
    try {
        if (val == undefined) {
            console.log(key + " が undefined なので 初期値 " + DefaultProfiles[key] + " で返答します(DFProf)");
            return DefaultProfiles[key];
        }
        if (typeof DefaultProfiles[key] == "boolean") {
            // 本則が true または false 要素の場合、旧プロファイルが "1" または "0" の場合に本則に矯正する
            if (typeof val != "boolean") {
                if (val == "1") {
                    console.log(key + " は旧方式のため " + val + " → true に矯正し返答します(DFProf)");
                    // ストレージを修正
                    let ary = {};
                    ary[key] = true;
                    browser.storage.local.set(ary, function() {
                        console.log("KJCLUB Plus はプロファイルを修正しました。");
                    });
                    return true;
                } else
                if (val == "0") {
                    console.log(key + " は旧方式のため " + val + " → false に矯正し返答します(DFProf)");
                    // ストレージを修正
                    let ary = {};
                    ary[key] = false;
                    browser.storage.local.set(ary, function() {
                        console.log("KJCLUB Plus はプロファイルを修正しました。");
                    });
                    return false;
                }
                console.log(key + " は不明な方式のため " + val + " → 初期値 " + DefaultProfiles[key] + " に矯正し返答します(DFProf)");
                return DefaultProfiles[key];
            }
        }
        // console.log("DFProf key="+key+" typeof "+typeof DefaultProfiles[key] );
        // console.log("DFProf this val="+val+" typeof "+typeof val );
    } catch (e) {}
    return val;
}
// [関数] デスクトップへ通常のテキスト通知メッセージ
// 使用する場合は manifest.json の "permissions" に "notifications" の記述が必要。
function BasicNotify(title, message) {
    // 処理結果を通知
    var opts = {
        iconUrl: '../icons/KJPlus-128.png',
        type: 'basic',
        title: title,
        message: message,
        priority: 1
    };
    browser.notifications.create('kjp_notification', opts);
}

// [String拡張] 文字列→HTML-Unicodeへ変換する関数
if (!String.prototype.encodeHexNumRef) {
    String.prototype.encodeHexNumRef = function() {
        return this.replace(/\W/g, function(c) {
            return "&#x" + c.charCodeAt(0).toString(16) + ";";
        });
    };
}

// [String拡張] 文字列→正規表現Unicodeへ変換する関数
if (!String.prototype.encodeHexNumReg) {
    String.prototype.encodeHexNumReg = function() {
        var cd, pref = {
            1: "\\u000",
            2: "\\u00",
            3: "\\u0",
            4: "\\u"
        };
        return this.replace(/\W/g, function(c) {
            return pref[(cd = c.charCodeAt(0).toString(16)).length] + cd;
        });
    };
}

// [String拡張] 正規表現Unicode→文字列へ変換する関数
if (!String.prototype.decodeHexNumReg) {
    String.prototype.decodeHexNumReg = function() {
        return this.replace(/\\u([a-fA-F0-9]{4})/g, function(matchedString, group1) {
            return String.fromCharCode(parseInt(group1, 16));
        });
    };
}

// [String拡張] HTML数値文字参照(16進数)をデコードする関数
if (!String.prototype.decodeHexNumRef) {
    String.prototype.decodeHexNumRef = function() {
        return this.replace(/&#x([0-9a-f]+);/ig, function(match, $1, idx, all) {
            return String.fromCharCode('0x' + $1);
        });
    }
}

// [String拡張] HTML数値文字参照(10進数)をデコードする関数
if (!String.prototype.decodeDecNumRef) {
    String.prototype.decodeDecNumRef = function() {
        return this.replace(/&#(\d+);/ig, function(match, $1, idx, all) {
            return String.fromCharCode($1);
        });
    }
}

// [String拡張] HTML数値文字参照をデコードする関数
if (!String.prototype.decodeNumRef) {
    String.prototype.decodeNumRef = function() {
        return this.decodeHexNumRef().decodeDecNumRef();
    }
}

// [String拡張] \u形式の参照をデコードする関数
if (!String.prototype.decodeNumReg) {
    String.prototype.decodeNumReg = function() {
        return this.replace(/\\u([a-fA-F0-9]{4})/g, function(a0, a1) {
            return String.fromCharCode(parseInt(a1, 16));
        });
    }
}

// [String拡張] 国際化表記対応のため文字列フォーマットに対応させる関数
if (!String.prototype.format) {
    String.prototype.format = function() {
        var args = arguments;
        return this.replace(/{(\d+)}/g, function(match, number) {
            return typeof args[number] != 'undefined' ? args[number] : match;
        });
    };
}

// [サービス関数] 配列をアンエスケープして返す (NEW:2023/04/30)
function AnyUnescape(aryIn) {
    var aryOut = [];
    for (var i = 0; i < aryIn.length; i++) {
        var sIn = aryIn[i];
        var sOut = sIn.decodeHexNumReg();
        // console.log(sIn + '→' + sOut);
        aryOut.push(sOut);
    }
    return aryOut;
}

// [関数] テキストリストないの配列をデコードして返す
function AryDecodeNum(aList) {
    var aryDec = [];
    for (var i = 0; i < aList.length; i++) {
        var sDec = aList[i].decodeNumReg().decodeNumRef();
        if (sDec == aList[i]) {
            // デコード前後が同じテキストなのでセット不要
            continue;
        }
        aryDec.push(sDec);
    }
    return aryDec;
}

// [関数] ニックネームでホワイトリスト以外の文字が使われているか判定(なりすまし判定)
function isBadNickname(username) {
    var re = /[^\u0020-\u007e\u00A0-\u00ab\u00Ae-\u00b6\u00Ae-\u00b7\u00b9-\u00bf\u03a3-\u0482\u2014-\u2027\u2030-\u2049\u2100-\u214f\u2150-\u21ff\u2200-\u22f1\u23e9-\u23fa\u2460-\u24fe\u2500-\u257f\u2580-\u259f\u25a0-\u25ff\u2600-\u27bf\u3000-\u301f\u3041-\u3096\u309b-\u309e\u30a1-\u30fe\u3280-\u32fe\u3300-\u33ff\u3400-\u4db5\u4e00-\u9fd5\uac00-\ud7a3\uf900-\ufa6d\uff01-\uff9f]+/g;
    var found = re.test(username);
    return found;
}

// [関数] ユーザーツールチップテキストの作成
function UserTooltipString(userid, username, message) {
    var txt = "USER ID: ";
    if (userid != null) {
        txt = txt + "#" + userid;
    } else {
        txt = txt + "*Undetectable";
    }
    txt = txt + "\n";
    txt = txt + "NICKNAME: " + username + " (" + username.length + " characters)";
    txt = txt + "\n";
    txt = txt + "ENCODE: " + username.encodeHexNumReg();

    // +"数値文字参照表記 "+username.encodeHexNumRef()+"\n"
    if (message != "") {
        txt = txt + "\n" + message;
    }
    return txt;
}