// *************************************************************************
// [内容] オプション設定の詳細ページ「ユーザーリスティング」のスクリプト。
// [詳細] ユーザーリスティングを実現するためのスクリプト。
// *************************************************************************
// [互換] browserの名前空間がなけれぱchromeの名前空間を使用する。
var browser = browser || chrome;

// [関数] 詳細ページの「KJCLUB IDリスト」の表示を更新する
function handlerKJIDListUpdate(resp) {

	if(!resp) {
		return;
	}
	
	if(resp.response=="OK") {
		var aRemoveUserid = SplitListUserid(Before["kjclub_userfiltering_nicknames"]);
		var aMarkUserid = SplitListUserid(Before["kjclub_usermarking_nicknames"]);

		var aRemoveUsername = SplitListNickname(Before["kjclub_userfiltering_nicknames"]);
		Array.prototype.push.apply( aRemoveUsername, AryDecodeNum(aRemoveUsername) );
		var aRemoveRegularUsername = SplitListRegularNickname(Before["kjclub_userfiltering_nicknames"]);

		var aMarkUsername = SplitListNickname(Before["kjclub_usermarking_nicknames"]);
		Array.prototype.push.apply( aMarkUsername, AryDecodeNum(aMarkUsername) );
		var aMarkRegularUsername = SplitListRegularNickname(Before["kjclub_usermarking_nicknames"]);

		var fBadNicknameRemove=Before["kjclub_userfiltering_badnickname"];

		var elIDList=document.getElementById("kjclub_idlist");
		
		while( elIDList.firstChild ){	// 表示をクリアする
		  elIDList.removeChild( elIDList.firstChild );
		}
		
		var IDInfos=resp.infos;
		
		var elTable = document.createElement("table");
		elTable.className = "record_table";
		
		for(var i=0;i<IDInfos.length;i++) {
			if(i>=50) {
				break;
			}
			var info=IDInfos[i];
			// console.log("userid="+info.userid);

			var remove=false;
			var mark=false;
			var filter="normal";
			
			var extraRemove=false;
			var extraMark=false;
			
			if( aRemoveUserid.indexOf(info.userid)>=0 ) {
				remove=true;
				filter="remove";
			}
			else {
				if( aMarkUserid.indexOf(info.userid)>=0 ) {
					mark=true;
					filter="mark";
				}
			}

			var elDiv = document.createElement("tr");
			elDiv.className = "record_clip nation_"+info.nation;

			elDiv.setAttribute("nation",info.nation);
			elDiv.setAttribute("userid",info.userid);
			elDiv.setAttribute("username",info.username);
			elDiv.setAttribute("filter",filter);

			// 国判定
			var elSpanNation = document.createElement("td");
			elSpanNation.className = "record_data_nation";
			var elTEXTNation = document.createTextNode(info.nation);
			elSpanNation.appendChild(elTEXTNation);

			// フィルター状態
			var elTdFilter = document.createElement("td");
			var elSpanFilter = document.createElement("span");
			elTdFilter.className = "record_data_filter";

			var filterText="〇";
			var filterTips="このIDの文書は通常通り表示します";
			if( remove ) {
				filterText="✖";
				filterTips="このIDの文書は除去されます";
			}
			else
			if( mark ) {
				filterText="✅";
				filterTips="このIDの文書は強調表示されます";
			}

			// 正規表現ニックネームで照合
			var addRemoveConnect="";
			if( !remove ) { addRemoveConnect="ただし、"; }
			for (var eDj = aRemoveRegularUsername.length; eDj--;) {
				var re = new RegExp( aRemoveRegularUsername[eDj] );
				if ( re.test(info.username) ) {
					remove=true;
					extraRemove=true;
					filterTips=filterTips+"\n"+addRemoveConnect+"ニックネームの正規表現評価により除去されます";
					break;
				}
			}
			// 完全一致ニックネームで照合(数値文字参照も考慮)
			for (var eDj = aRemoveUsername.length; eDj--;) {
				if ( info.username == aRemoveUsername[eDj] ) {
					remove=true;
					extraRemove=true;
					filterTips=filterTips+"\n"+addRemoveConnect+"ニックネームの評価により除去されます";
					break;
				}
			}

			// 正規表現ニックネームで照合
			if( !remove ) {
				var addMarkConnect="";
				if( !mark ) { addMarkConnect="ただし、"; }
				for (var eDj = aMarkRegularUsername.length; eDj--;) {
					var re = new RegExp( aMarkRegularUsername[eDj] );
					if ( re.test(info.username) ) {
						mark=true;
						extraMark=true;
						filterTips=filterTips+"\n"+addMarkConnect+"ニックネームの正規表現評価により強調されます";
						break;
					}
				}
				// 完全一致ニックネームで照合(数値文字参照も考慮)
				for (var eDj = aMarkUsername.length; eDj--;) {
					if ( info.username == aMarkUsername[eDj] ) {
						mark=true;
						extraMark=true;
						filterTips=filterTips+"\n"+addMarkConnect+"ニックネームの評価により強調されます";
						break;
					}
				}
			}
			
			if( fBadNicknameRemove && isBadNickname(info.username) ) {
				extraRemove=true;
				filterTips=filterTips+"\n"+"なりすまし等の疑いがある不穏な加工がされたニックネームです";
			}
			
			var tooltip=UserTooltipString( info.userid, info.username, filterTips );
			
			var elTEXTFilter = document.createTextNode(filterText);
			elTdFilter.addEventListener("click",switchFilter);
			elTdFilter.setAttribute("title", filterTips );

			elSpanFilter.appendChild(elTEXTFilter);
			elTdFilter.appendChild(elSpanFilter);

			// ユーザーIDおよびユーザー名
			var elTdUsername = document.createElement("td");
			elTdUsername.className = "record_data_mainbody";

			var elSpanUsername = document.createElement("span");
			elSpanUsername.className = "record_data_username";
			elSpanUsername.setAttribute("title", tooltip );
			var elTEXTUsername = document.createTextNode(info.username);
			elSpanUsername.appendChild(elTEXTUsername);

			var elSpanUserID = document.createElement("span");
			elSpanUserID.className = "record_data_userid";
			elSpanUserID.setAttribute("title", tooltip );
			var elTEXTUserID = document.createTextNode("#"+info.userid);
			elSpanUserID.appendChild(elTEXTUserID);

			var elWbr = document.createElement("wbr");

			elTdUsername.appendChild(elSpanUsername);
			elTdUsername.appendChild(elWbr);
			elTdUsername.appendChild(elSpanUserID);

			// エキストラ状態表示
			if( extraRemove || extraMark ) {
				var elSpanExtra = document.createElement("span");
				elSpanExtra.className = "record_data_extra";
				elSpanExtra.setAttribute("title", tooltip );
				var elTEXTExtra = document.createTextNode("※");
				elSpanExtra.appendChild(elTEXTExtra);
				elTdUsername.appendChild(elSpanExtra);
			}
			
			// レコード構築
			elDiv.appendChild(elTdFilter);
			elDiv.appendChild(elSpanNation);
			elDiv.appendChild(elTdUsername);

			elTable.appendChild(elDiv);

		}

		elIDList.appendChild(elTable);

		// IDリスト送信機能は、NETFONT7.NET管理人のnetfont7のみ
		// ※受領にはNETFONT7.NETへの本人のログインが必要ですので、突破しても無意味です。
		// * All users except this add-on administrator can not use this function.
		// * The unauthorized data transmission is protected by the login function on the receiving server side.
		var sIDListPostDisplay = (Before["netfont7_login_id"] == "netfont7" ? "inline" : "none");
		document.getElementById("kjclub_idlist_post").style.display=sIDListPostDisplay;
	}
}

// [関数] 詳細ページの「KJCLUB IDリスト」の表示を更新する
function KJIDListUpdate() {
	browser.runtime.sendMessage({
			request: "getIDInformations"
		},
		handlerKJIDListUpdate );
}

// [関数] 詳細ページの「KJCLUB IDリスト」をNETFONT7.NETへ送信する(※ログインが必要)
// * Send "KJCLUB ID List" to NETFONT7.NET.
// * All users except this add-on administrator can not use this function.
// * The unauthorized data transmission is protected by the login function on the receiving server side.
var idinfoPostUrl="https://www.netfont7.net/enjoybrowser/editid.cgi";
var IDInfoPostQueue=null;
var IDInfoPostInterval=2000;
var PostedID=[];
function KJIDPostByQueue() {
	var interval=IDInfoPostInterval;
	if( IDInfoPostQueue.length<=0 ) {
		// 配列終了
		console.log("POST終了");
		document.getElementById("kjclub_idlist_post").textContent="送信)";
		IDInfoPostQueue=null;
		return;
	}
	var info=IDInfoPostQueue[IDInfoPostQueue.length-1]; // キューの最後尾から取り出す
	IDInfoPostQueue.pop(); // キューの最後尾を削除

	if( info.nation == "JP" || info.nation == "KR" ) {
		if( PostedID.indexOf(info.userid) >= 0 ) {
			// 送信済み
			interval=50;
			console.log("SKIP(残り"+IDInfoPostQueue.length+") id="+info.userid+" category="+info.category+" datetime="+info.datetime);
		}
		else {
			var data={
				page:"idlist", 
				method:"updateid", 
				selfnation:info.nation.toUpperCase(), 
				id:info.userid, 
				name:info.username,
				category:info.category,
				datetime:Math.floor(info.datetime/1000)
			};
			document.getElementById("kjclub_idlist_post").textContent="送信中(残り"+IDInfoPostQueue.length+"件)";
			PostedID.push(info.userid);
			console.log("POST(残り"+IDInfoPostQueue.length+") id="+info.userid+" category="+info.category+" datetime="+info.datetime);
			execPost( idinfoPostUrl, "idlisthidframe", data );
		}
	}
	
	setTimeout( KJIDPostByQueue,interval );
}
function handlerKJIDListPost(resp) {
	if(IDInfoPostQueue!=null) {
		// キューは実行中なので戻る
		console.log("キュー実行中なので実行しません");
		return;
	}
	if(resp.response=="OK") {
		console.log("リスト更新");
		handlerKJIDListUpdate(resp); //表示を最新に更新する
		IDInfoPostQueue=resp.infos;
		console.log("POST開始");
		setTimeout( KJIDPostByQueue,IDInfoPostInterval );
	}
}

// [関数] 詳細ページの「KJCLUB IDリスト」をNETFONT7.NETへ送信する(※ログインが必要)
function KJIDListPost() {
	browser.runtime.sendMessage({
			request: "getIDInformations"
		},
		handlerKJIDListPost );
}

// [関数] フィルタ切り替えボタンが押された時の処理 (※AMO版は処理を実行しない)
function switchFilter(e) {
	var elRecord=e.target.parentNode.parentNode;
	var filter=elRecord.getAttribute("filter");
	var userid=elRecord.getAttribute("userid");
	var username=elRecord.getAttribute("username");
	
	if( userid !=null && userid != "" ) {
		request="switchRemove";
		if( filter=="normal" ) {
			request="switchRemove";
		}
		else
		if( filter=="remove" ) {
			request="switchMark";
		}
		else
		if( filter=="mark" ) {
			request="switchMark";
		}
		browser.runtime.sendMessage({
				request: request,
				userid: userid,
				username: username
			},
			function(resp) {
			}
		);
	}
}

